//+-------------------------------------------------------------------------------------+
//|                                                                 CTG-Mirror v1_2.mq4 |
//|                                                                                     |
//|                                                                                     |
//+-------------------------------------------------------------------------------------+
#property copyright "Copyright  2007, ChaosTradingGroup.com "
#property link      ""
//        ,        .
//    .       ,   .
//      ,      .        .

#property indicator_chart_window
//---- input parameters
extern bool      sled = false;
extern int       NumBars = 55;


double k3=0;
datetime rz;
datetime rz1;
datetime it;
datetime it1;
datetime ut,ut1,unt,time0,time1,time0prev,time1prev,unt1;

int i,Method=0,ip,invert=0,pn,i0n,Nbars,dm1=0,prov,volumecenter=1,
    ipn,itr0,itr1,itr2,itr3,itr4,itr5,itr6,itr7,itr8,itr9,itr10,itr11,itr12,itr13,itr14;
int t0,tp,te,te1,z=1,r,s3,razmer,mz,MaK,DK=0;
double it0,it2,it3,it4,distMA=0,VolMA=1,it5,it6,it7,it8,it9,it10,it11,it12,it13,it14;
double k0,k,k1,k2,km,km1,km2,km3,km4,g,K2,K3,K21,k4,k5,sx,up,up1,unp,unp1,price0,
       price1,priceMA,price0prev,price1prev,priceMAprev;
static string  text_comment;
color clr;


int r2=32,dist,vol;

int  s,s1=0,s2,masZ,map,mas,map1,mas1,m,dist1,sk;
double  Bear,Bear2,Bear3,Bear31,Bull,Bull4,l;
int  z0=0;
int  z1=0;
bool Activate;

//+-------------------------------------------------------------------------------------+
//|                                                       |
//+-------------------------------------------------------------------------------------+
void init() 
{
  Activate = False;
  i = NumBars;
  ip = i - NumBars;
  if (ip < 1)
    ip=1;
  tp = Time[ip];
  prov=0;
  for (z = 0; z <= 100; z++)
    if (ObjectFind("f02"+z)<=-1)
      if (ObjectFind("f00"+z)<=-1)
        {
         prov = 1;
         break;
        }
  if (prov == 0)
    return(-1);

  switch (z)
    {
     case 0: clr = Red; break;
     case 1: clr = MediumSeaGreen; break;
     case 2: clr = DodgerBlue; break;
     case 3: clr = Orange; break;
     case 4: clr = LimeGreen; break;
     case 5: clr = DeepSkyBlue; break;
     case 6: clr = DeepPink; break;
     case 7: clr = Green; break;
     case 8: clr = Blue; break;
     case 9: clr = Magenta; break;
     case 10: clr = MediumTurquoise; break;
     default: clr=Red; break;
    } 


  ObjectCreate("f00"+z,2,0,Time[ip], Close[i]-(High[i]-Low[i])*4, Time[i], Close[i]-(High[i]-Low[i])*4 );
  ObjectSet("f00"+z,OBJPROP_LEVELCOLOR,clr); 
  ObjectSet("f00"+z,OBJPROP_COLOR,clr);  
  ObjectSet("f00"+z,OBJPROP_STYLE,3);   
  ObjectSet("f00"+z,OBJPROP_RAY,0); 
  
  Activate = True;
  return(0);
}

//+-------------------------------------------------------------------------------------+
//|  start                                                             |
//+-------------------------------------------------------------------------------------+
int start()
  {
   if (!Activate) return(0);  //     ,   
   
   if (Nbars!=ip-i || time0!=ObjectGet("f00"+z,OBJPROP_TIME2) ||
       time1!=ObjectGet("f00"+z, OBJPROP_TIME1) || 
       price0!=ObjectGet("f00"+z, OBJPROP_PRICE2) || 
       price1!=ObjectGet("f00"+z, OBJPROP_PRICE1))
     {  
      if (ObjectFind("f00"+z) == 0) 
        {
            i = iBarShift(Symbol(),Period(),ObjectGet("f00"+z,OBJPROP_TIME2));
            ip = iBarShift(Symbol(),Period(),ObjectGet("f00"+z,OBJPROP_TIME1));
   
            it = ObjectGet("f00"+z,OBJPROP_TIME2);
            it1 = ObjectGet("f00"+z,OBJPROP_TIME1);

            mz = 0;
            razmer = 0;
            if (it>Time[0])
              {
               razmer = it-Time[0];
               mz = 1;
              }
            if (it1>Time[0])
              {
               razmer = it1-Time[0];
               mz = 1;
              }

            switch ( Period() )
              {
               case 1:     razmer=razmer/60;sk=60;  break;
               case 5:     razmer=razmer/300;sk=300;  break;
               case 15:    razmer=razmer/900;sk=900;  break;
               case 30:    razmer=razmer/1800;sk=1800;  break;
               case 60:    razmer=razmer/3600;sk=3600;  break;
               case 240:   razmer=razmer/14400;sk=14400;  break;
               case 1440:  razmer=razmer/86400;sk=86400;  break;         
               case 10080:   razmer=razmer/604800;sk=604800;  break;
               case 43200:  razmer=razmer/2592000;sk=2592000;  break;          
         
               default: break;
              }

            time0 = ObjectGet("f00"+z,OBJPROP_TIME2);
            time1 = ObjectGet("f00"+z,OBJPROP_TIME1);
            price0 = ObjectGet("f00"+z,OBJPROP_PRICE2);
            price1 = ObjectGet("f00"+z,OBJPROP_PRICE1);
            Nbars = ip-i;  
  
            if (Nbars<0)
              Nbars=-Nbars;

            f2();

        }
     }

   return(0);
  }
//+------------------------------------------------------------------+

void deinit() 
{
 Comment("");
 if (ObjectFind("f00"+z) == 0)
   ObjectDelete("f00"+z);
 if (ObjectFind("f01"+z) == 0)  
   ObjectDelete("f01"+z);
 if (ObjectFind("f03"+z) == 0)  
   ObjectDelete("f03"+z);

 if (!sled)
   for(z=0; z<=20; z++)
     {
      ObjectDelete("f02"+z);
      for (s3=0; s3<=1000; s3++)
        ObjectDelete("ar"+s3+z);
     }
}

void f2()
{
 dist = Nbars;

 if (m == 0)
   {
    ObjectCreate("f01"+z,2,0,Time[r],0,Time[r],(High[r]-Low[r])/2+Low[r]);
    ObjectSet("f01"+z,OBJPROP_RAY,0);
    ObjectSet("f01"+z,OBJPROP_COLOR,clr); 
    ObjectSet("f01"+z,OBJPROP_STYLE,3);
  
    ObjectCreate("f02"+z,22,0,Time[r],(High[r]-Low[r])/2+Low[r]);
    ObjectSet("f02"+z,OBJPROP_ARROWCODE,108);
    ObjectSet("f02"+z,OBJPROP_COLOR,clr); 
    ObjectSet("f02"+z,OBJPROP_WIDTH,volumecenter);

    ObjectCreate("f03"+z,22,0,time0,(High[r]-Low[r])/2+Low[r]-distMA);
    ObjectSet("f03"+z,OBJPROP_ARROWCODE,244);
    ObjectSet("f03"+z,OBJPROP_COLOR,clr); 
    ObjectSet("f03"+z,OBJPROP_WIDTH,1);

    for(s3=0; s3<=dist; s3++)
      {
       ObjectCreate("ar"+s3+z,2,0,Time[r-s3+1],0,Time[r-s3],0);
       ObjectSet("ar"+s3+z,OBJPROP_RAY,0);
       ObjectSet("ar"+s3+z,OBJPROP_COLOR,clr); 

       ObjectSet("ar"+s3+z,OBJPROP_WIDTH,2);
      }
    m = 1;
    dist1 = dist;
   }

 if (dist1<dist+razmer)
   {
    for(s3=dist1; s3<=dist+razmer; s3++) 
      {
       ObjectCreate("ar"+s3+z,2,0,Time[r-s3-1],0,Time[r-s3],0); 
       ObjectSet("ar"+s3+z,OBJPROP_RAY,0); 
       ObjectSet("ar"+s3+z,OBJPROP_COLOR,clr); 
       ObjectSet("ar"+s3+z,OBJPROP_WIDTH,2);
      }  
   dist1=dist+razmer;    
  }
 if (dist1>dist+razmer)
   {
    for (s3=dist1; s3>=dist+razmer; s3--) 
      ObjectDelete("ar"+s3+z);
    dist1=dist+razmer;
   }

 r = i;
 NumBars = ip;
 rz = Time[0];
 rz1 = it1;
 k1 = (ObjectGet("f00"+z,OBJPROP_PRICE1)-ObjectGet("f00"+z,OBJPROP_PRICE2))*5/(r - NumBars);

 if (DK==0)
   {
    distMA = (((High[r]-Low[r])/2+Low[r]-price0)/4)/((High[r]-Low[r])/2+Low[r]-price0);
    DK = 1;
   }

 f3();

 ObjectMove("f01"+z,0,time0,(High[r]-Low[r])/2+Low[r]); 
 ObjectMove("f01"+z,1,time0,price0); 
 ObjectMove("f02"+z,0,time0,(High[r]-Low[r])/2+Low[r]);
 ObjectMove("f03"+z,0,time0-sk*8,(High[r]-Low[r])/2+Low[r]-distMA*((High[r]-Low[r])/2+Low[r]-price0));

 if (price0<(High[r]-Low[r])/2+Low[r])
   invert=0;
  else
   invert=1;

 MaK=VolMA;

 if (MaK<2 && MaK>=0)
   {
    MaK=1;
    Method=1;
   }
 if (MaK<0)
   {
    Method=2;
    MaK=0;
   }

 if (MaK>=2)
   Method=0;

 if (MaK>=144)
   MaK=144;

 Comment("  "+MaK );
 
 if (dist1<=89) ObjectSet("f02"+z,OBJPROP_WIDTH,1);
 if (dist1>=89 && dist1<=233) ObjectSet("f02"+z,OBJPROP_WIDTH,2);
 if (dist1>=233 && dist1<=610) ObjectSet("f02"+z,OBJPROP_WIDTH,3);
 if (dist1>=610 && dist1<=1000) ObjectSet("f02"+z,OBJPROP_WIDTH,4);
 if (dist1>=1000 ) ObjectSet("f02"+z,OBJPROP_WIDTH,5);

 for (s3=0; s3<=dist; s3++)
   {
    if (i<ip)
      {
       s = r+s3;

       if (invert==0)
         {
          if (Method==0)
            {
             ObjectMove("ar"+s3+z,0,Time[s],((High[r]-Low[r])/2+Low[r])*2-iMA(NULL,0,MaK,1-MaK/2,0,4,r-s3)-k1*s3); 
             ObjectMove("ar"+s3+z,1,Time[s-1],((High[r]-Low[r])/2+Low[r])*2-iMA(NULL,0,MaK,1-MaK/2,0,4,r-s3+1)-k1*(s3-1));
            }
          if (Method==1)
            {
             ObjectMove("ar"+s3+z,0,Time[s],((High[r]-Low[r])/2+Low[r])*2-((High[r-s3]-Low[r-s3])/2+Low[r-s3])-k1*s3); 
             ObjectMove("ar"+s3+z,1,Time[s-1],((High[r]-Low[r])/2+Low[r])*2-((High[r-s3+1]-Low[r-s3+1])/2+Low[r-s3+1])-k1*(s3-1));
            }

          if (Method==2)
            {
             ObjectMove("ar"+s3+z,0,Time[s],((High[r]-Low[r])/2+Low[r])*2-Low[r-s3]-k1*s3); 
             ObjectMove("ar"+s3+z,1,Time[s],((High[r]-Low[r])/2+Low[r])*2-High[r-s3]-k1*s3);
            }
        }
       else
        {
         if (Method==0)
           {
            ObjectMove("ar"+s3+z,0,Time[s],iMA(NULL,0,MaK,1-MaK/2,0,4,r-s3)-k1*s3); 
            ObjectMove("ar"+s3+z,1,Time[s-1],iMA(NULL,0,MaK,1-MaK/2,0,4,r-s3+1)-k1*(s3-1));
           }
         if (Method==1)
           {
            ObjectMove("ar"+s3+z,0,Time[s],((High[r-s3]-Low[r-s3])/2+Low[r-s3])-k1*s3); 
            ObjectMove("ar"+s3+z,1,Time[s-1],((High[r-s3+1]-Low[r-s3+1])/2+Low[r-s3+1])-k1*(s3-1));
           }

         if (Method==2)
           {
            ObjectMove("ar"+s3+z,0,Time[s],Low[r-s3]-k1*s3); 
            ObjectMove("ar"+s3+z,1,Time[s],High[r-s3]-k1*s3);
           }
        } // else
      } // if (i < ip)

    if (i>ip)
      {
       s = r-s3;

       if (invert==0)
         {
          if (Method==0)
            {
             ObjectMove("ar"+s3+z,0,Time[s],((High[r]-Low[r])/2+Low[r])*2-iMA(NULL,0,MaK,1-MaK/2,0,4,r+s3)+k1*s3); 
             ObjectMove("ar"+s3+z,1,Time[s-1],((High[r]-Low[r])/2+Low[r])*2-iMA(NULL,0,MaK,1-MaK/2,0,4,r+s3+1)+k1*(s3+1));
            } 
          if (Method==1)
            {
             ObjectMove("ar"+s3+z,0,Time[s],((High[r]-Low[r])/2+Low[r])*2-((High[r+s3]-Low[r+s3])/2+Low[r+s3])+k1*s3); 
             ObjectMove("ar"+s3+z,1,Time[s-1],((High[r]-Low[r])/2+Low[r])*2-((High[r+s3+1]-Low[r+s3+1])/2+Low[r+s3+1])+k1*(s3+1));
            }
          if (Method==2)
            {
             ObjectMove("ar"+s3+z,0,Time[s],((High[r]-Low[r])/2+Low[r])*2-Low[r+s3]+k1*s3); 
             ObjectMove("ar"+s3+z,1,Time[s],((High[r]-Low[r])/2+Low[r])*2-High[r+s3]+k1*s3);
            }
         }
        else
         {
          if (Method==0)
            {
             ObjectMove("ar"+s3+z,0,Time[s],iMA(NULL,0,MaK,1-MaK/2,0,4,r+s3)+k1*s3); 
             ObjectMove("ar"+s3+z,1,Time[s-1],iMA(NULL,0,MaK,1-MaK/2,0,4,r+s3+1)+k1*(s3+1));
            }
          if (Method==1)
            {
             ObjectMove("ar"+s3+z,0,Time[s],((High[r+s3]-Low[r+s3])/2+Low[r+s3])+k1*s3); 
             ObjectMove("ar"+s3+z,1,Time[s-1],((High[r+s3+1]-Low[r+s3+1])/2+Low[r+s3+1])+k1*(s3+1));
            }
          if (Method==2)
            {
             ObjectMove("ar"+s3+z,0,Time[s],Low[r+s3]+k1*s3); 
             ObjectMove("ar"+s3+z,1,Time[s],High[r+s3]+k1*s3);
            }
         }
      } // if (i > ip)
   } // for (s3=0; s3<=dist; s3++)

 s3=dist-1;

 for (s=rz; s<=rz1; s+=sk)
   {
    s3 += 1;
    if (invert==0)
      {
       if (Method==0)
         {
          ObjectMove("ar"+s3+z,0,s,((High[r]-Low[r])/2+Low[r])*2-iMA(NULL,0,MaK,1-MaK/2,0,4,r+s3)+k1*s3); 
          ObjectMove("ar"+s3+z,1,s+sk,((High[r]-Low[r])/2+Low[r])*2-iMA(NULL,0,MaK,1-MaK/2,0,4,r+s3+1)+k1*(s3+1));
         }
       if (Method==1)
         {
          ObjectMove("ar"+s3+z,0,s,((High[r]-Low[r])/2+Low[r])*2-((High[r+s3]-Low[r+s3])/2+Low[r+s3])+k1*s3); 
          ObjectMove("ar"+s3+z,1,s+sk,((High[r]-Low[r])/2+Low[r])*2-((High[r+s3+1]-Low[r+s3+1])/2+Low[r+s3+1])+k1*(s3+1));
         }

       if (Method==2)
         {
          ObjectMove("ar"+s3+z,0,s,((High[r]-Low[r])/2+Low[r])*2-Low[r+s3]+k1*s3); 
          ObjectMove("ar"+s3+z,1,s,((High[r]-Low[r])/2+Low[r])*2-High[r+s3]+k1*s3);
         }
      }
     else
      {
       if (Method==0)
         {
          ObjectMove("ar"+s3+z,0,s,iMA(NULL,0,MaK,1-MaK/2,0,4,r+s3)+k1*s3); 
          ObjectMove("ar"+s3+z,1,s+sk,iMA(NULL,0,MaK,1-MaK/2,0,4,r+s3+1)+k1*(s3+1));
         }
       if (Method==1)
         {
          ObjectMove("ar"+s3+z,0,s,((High[r+s3]-Low[r+s3])/2+Low[r+s3])+k1*s3); 
          ObjectMove("ar"+s3+z,1,s+sk,((High[r+s3+1]-Low[r+s3+1])/2+Low[r+s3+1])+k1*(s3+1));
         }
       if (Method==2)
         {
          ObjectMove("ar"+s3+z,0,s,Low[r+s3]+k1*s3); 
          ObjectMove("ar"+s3+z,1,s,High[r+s3]+k1*s3);
         }
      } // else
   } // for (s=rz; s<=rz1; s+=sk)
}


void f3()
{
 priceMA = ObjectGet("f03"+z,OBJPROP_PRICE1);
 if (time0==time0prev && time1==time1prev && price0==price0prev && price1==price1prev && priceMA!=priceMAprev )
   {
    distMA=((High[r]-Low[r])/2+Low[r]-priceMA)/((High[r]-Low[r])/2+Low[r]-price0);
    if (distMA<=0.03)
      distMA=-0.03;
    if (distMA>=4.5 )
      distMA=4.5;
    VolMA=distMA*34;
   }
  else 
   {
    time0prev=time0;
    time1prev=time1;
    price0prev=price0;
    price1prev=price1;
    priceMAprev=priceMA;
   }
}